/**************************************************************

File Name:		SS_FIR_test.asm

Date Modified:	11/18/99	GGL
				05/01/00	RFG
				09/19/04	JDT		

Description:	Program to call SS_FIR.asm

**************************************************************/

#include    "def21364.h"					/* Symbol Definition File */

#define     TAPS    64						/* length of filter */
#define     N       128						/* number of samples */

.extern	ss_fir;

/* DM data */
.section/dm seg_dmda;						/* Segments are declared in the .ldf file*/
.ALIGN 2;									/* Set alignment to long-word boundary for next variable */
.var    dline[TAPS+1];						/* delay line compensate for circ buffer, see comments in SS_FIR.asm */
.ALIGN 2;
.var    input[N] = "input.dat";			/* array of samples */


/* PM data */
.section/dm seg_pmda;
.ALIGN 2;
.var    coeffs[TAPS] = "ssfcoeffs.dat";		/* Filter coefficients */
.ALIGN 2;
.var    output[N];				    		/* Output array */


/* PM interrupt vector code */
.section/pm   seg_rth;
Reserved_1:     rti; nop; nop; nop;
Chip_Reset:     idle; jump start; nop; nop;


/* program memory code */
.segment/pm seg_pmco;

start:
/*--------------------- Setup modify registers for arrays --------------------*/
	m1 = 1;
	m2 = -1;
	m3 = 2;

  	m9 = 2;
	m10= 1;
/*----------------------------------------------------------------------------*/



/*--------------------- Initialization delay line ----------------------------*/
	b0 = dline;
	l0 = @dline-1;

	f8=0.0;
	lcntr = TAPS, do clear_fir until lce;
clear_fir:  dm(i0,m1) = f8;

	i0 = dline;
/*----------------------------------------------------------------------------*/



/*-------------- Setup DAGs for input/output/coeffs and call ss_fir ----------*/
	r3 = TAPS;
	r3 = lshift r3 by -1;					/* r3 = taps/2 due to SIMD mode */
	r0 = 3;									/* 3 macs outside of fir mac loop */
	r3 = r3 - r0;							/* r3 = taps/2 - 3 for fir mac loop counter */ 
	
	b1 = input;
	l1 = 0;

	b9 = output;
	l9 = 0;

	b8 = coeffs;
	l8 = @coeffs;
	
lcntr = N, do fir_loop until lce;
			call ss_fir (db);				/* Call fir */
			f0 = dm(i1,m1);					/* Read one sample */
			nop;							/* Call can't be in last three locations of a loop */
fir_loop:	pm(i9,m10)=f8;					/* Write result to output */
/*----------------------------------------------------------------------------*/
  
	  

/* Terminate and wait */
wait1:	idle;
		jump wait1;
